#ifndef DOXYGEN_SHOULD_SKIP_THIS

#ifndef FILE__3DSDEF_H
#define FILE__3DSDEF_H

// All Chunks defines for 3ds starts with CHUNK3DS_
#define CHUNK3DS_VERSION			0x0002

#define CHUNK3DS_COLOR_F			0x0010
#define CHUNK3DS_COLOR_24			0x0011
#define CHUNK3DS_LIN_COLOR_24		0x0012
#define CHUNK3DS_LIN_COLOR_F		0x0013

#define CHUNK3DS_INT_PERCENTAGE		0x0030
#define CHUNK3DS_FLOAT_PERCENTAGE	0x0031


#define CHUNK3DS_SMAGIC				0x2D2D					// Shaper
#define CHUNK3DS_LMAGIC				0x2D3D					// Lofter
#define CHUNK3DS_MLIBMAGIC			0x3DAA					// Material
#define CHUNK3DS_MATMAGIC			0x3DFF					// Material

#define CHUNK3DS_MAIN3DS			0x4D4D			
	#define CHUNK3DS_MMAGIC				0x3D3D				// Mesh magic num 
		#define CHUNK3DS_MESH_VERSION		0x3D3E			// Version
		#define CHUNK3DS_MASTER_SCALE		0x0100
		#define CHUNK3DS_SOLID_BGND			0x1200
		#define CHUNK3DS_USE_SOLID_BGND		0x1201

		#define CHUNK3DS_DEFAULT_VIEW		0x3000
			#define CHUNK3DS_VIEW_TOP			0x3010
			#define CHUNK3DS_VIEW_BOTTOM		0x3020
			#define CHUNK3DS_VIEW_LEFT			0x3030
			#define CHUNK3DS_VIEW_RIGHT			0x3040
			#define CHUNK3DS_VIEW_FRONT			0x3050
			#define CHUNK3DS_VIEW_BACK			0x3060
			#define CHUNK3DS_VIEW_USER			0x3070
			#define CHUNK3DS_VIEW_CAMERA		0x3080
			#define CHUNK3DS_VIEW_WINDOW		0x3090

		#define CHUNK3DS_NAMED_OBJECT		0x4000	
			#define CHUNK3DS_OBJ_HIDDEN			0x4010
			#define CHUNK3DS_OBJ_VIS_LOFTER		0x4011
			#define CHUNK3DS_OBJ_DOESNT_CAST	0x4012
			#define CHUNK3DS_OBJ_MATTE			0x4013
			#define CHUNK3DS_OBJ_FAST			0x4014
			#define CHUNK3DS_OBJ_PROCEDURAL		0x4015
			#define CHUNK3DS_OBJ_FROZEN			0x4016
			#define CHUNK3DS_OBJ_DONT_RCVSHADOW 0x4017
			
				#define CHUNK3DS_N_TRI_OBJECT			0x4100	// Mesh object.
					#define CHUNK3DS_POINT_ARRAY		0x4110	// Array of vertex.
					#define CHUNK3DS_POINT_FLAG_ARRAY	0x4111
					#define CHUNK3DS_FACE_ARRAY			0x4120	// Face array (triangles).
					#define CHUNK3DS_MSH_MAT_GROUP		0x4130
					#define CHUNK3DS_OLD_MAT_GROUP		0x4131
					#define CHUNK3DS_TEX_VERTS			0x4140	// Array of texture coo.
					#define CHUNK3DS_SMOOTH_GROUP		0x4150
					#define CHUNK3DS_MESH_MATRIX		0x4160
					#define CHUNK3DS_MESH_COLOR			0x4165
					#define CHUNK3DS_MESH_TEXTURE_INFO	0x4170
					#define CHUNK3DS_PROC_NAME			0x4181
					#define CHUNK3DS_PROC_DATA			0x4182
					#define CHUNK3DS_MSH_BOXMAP			0x4190
				#define CHUNK3DS_N_DIRECT_LIGHT		0x4600
					#define CHUNK3DS_DL_SPOTLIGHT		0x4610
					#define CHUNK3DS_DL_OFF				0x4620
					#define CHUNK3DS_DL_ATTENUATE		0x4625
					#define CHUNK3DS_DL_RAYSHAD			0x4627
					#define CHUNK3DS_DL_SHADOWED		0x4630
					#define CHUNK3DS_DL_LOCAL_SHADOW	0x4640
					#define CHUNK3DS_DL_LOCAL_SHADOW2	0x4641
					#define CHUNK3DS_DL_SEE_CONE		0x4650
					#define CHUNK3DS_DL_SPOT_RECTANGULAR 0x4651
					#define CHUNK3DS_DL_SPOT_OVERSHOOT	0x4652
					#define CHUNK3DS_DL_SPOT_PROJECTOR	0x4653
					#define CHUNK3DS_DL_EXCLUDE			0x4654
					#define CHUNK3DS_DL_RANGE			0x4655	/* Old style chunk -- don't write */
					#define CHUNK3DS_DL_SPOT_ROLL		0x4656
					#define CHUNK3DS_DL_SPOT_ASPECT		0x4657
					#define CHUNK3DS_DL_RAY_BIAS		0x4658
					#define CHUNK3DS_DL_INNER_RANGE		0x4659
					#define CHUNK3DS_DL_OUTER_RANGE		0x465A
					#define CHUNK3DS_DL_MULTIPLIER		0x465B
				#define CHUNK3DS_N_CAMERA			0x4700
					#define CHUNK3DS_CAM_SEE_CONE		0x4710
					#define CHUNK3DS_CAM_RANGES			0x4720
				#define CHUNK3DS_HIERARCHY			0x4F00
					#define CHUNK3DS_PARENT_OBJECT		0x4F10
					#define CHUNK3DS_PIVOT_OBJECT		0x4F20
					#define CHUNK3DS_PIVOT_LIMITS		0x4F30
					#define CHUNK3DS_PIVOT_ORDER		0x4F40
					#define CHUNK3DS_XLATE_RANGE		0x4F50

	#define CHUNK3DS_MATERIAL_EDITOR					0xAFFF
		#define CHUNK3DS_MATERIAL_NAME						0xA000
		#define CHUNK3DS_MATERIAL_AMBIENT					0xA010
		#define CHUNK3DS_MATERIAL_DIFUSSE					0xA020
		#define CHUNK3DS_MATERIAL_SPECULAR					0xA030
		#define CHUNK3DS_MATERIAL_SHININESS					0xA040
		#define CHUNK3DS_MATERIAL_SHININESS_STR				0xA041
		#define CHUNK3DS_MATERIAL_TRANSPARENCY				0xA050
		#define CHUNK3DS_MATERIAL_TRANSPARENCY_FALLOFF		0xA052
		#define CHUNK3DS_MATERIAL_REFLICTION				0xA053
		#define CHUNK3DS_MATERIAL_TWOSIDED					0xA081
		#define CHUNK3DS_MATERIAL_ADDTRANS					0xA083
		#define CHUNK3DS_MATERIAL_SELFILLUM					0xA084
		#define CHUNK3DS_MATERIAL_WIREFRAMEON				0xA085
		#define CHUNK3DS_MATERIAL_WIRETICKNESS				0xA087
		#define CHUNK3DS_MATERIAL_FACEMAP					0xA088
		#define CHUNK3DS_MATERIAL_INTRANC					0xA08A
		#define CHUNK3DS_MATERIAL_SOFTEN					0xA08C
		#define CHUNK3DS_MATERIAL_WIREINUNITS				0xA08E
		#define CHUNK3DS_MATERIAL_RENDERTYPE				0xA100

		#define CHUNK3DS_MATERIAL_MAP_TEXTURE1				0xA200
		#define CHUNK3DS_MATERIAL_MAP_TEXTURE2				0xA33A
		#define CHUNK3DS_MATERIAL_MAP_OPACITY				0xA210
		#define CHUNK3DS_MATERIAL_MAP_BUMP					0xA230
		#define CHUNK3DS_MATERIAL_MAP_SHININESS				0xA33C
		#define CHUNK3DS_MATERIAL_MAP_SPECULAR				0xA204
		#define CHUNK3DS_MATERIAL_MAP_SELFILLUM				0xA33D
		#define CHUNK3DS_MATERIAL_MAP_REFLECTION			0xA220
		
			// This chunks exist in each MAP_xxx chunk.
			#define CHUNK3DS_MATERIAL_MAPNAME	0xA300
			#define CHUNK3DS_MATERIAL_MAPVSCALE	0xA354
			#define CHUNK3DS_MATERIAL_MAPUSCALE	0xA356
			#define CHUNK3DS_MATERIAL_MAPUOFFS	0xA358
			#define CHUNK3DS_MATERIAL_MAPVOFFS	0xA35A

			#define CHUNK3DS_MATERIAL_MAP_PARAMETERS	0xA351
			#define CHUNK3DS_MATERIAL_BLUR_PROCENT		0xA353
			#define CHUNK3DS_MATERIAL_ROTATION_ANGLE	0xA35C
			#define CHUNK3DS_MATERIAL_RGB_LA_TINT1		0xA360
			#define CHUNK3DS_MATERIAL_RGB_LA_TINT2		0xA362
			#define CHUNK3DS_MATERIAL_RGB_TINT_R		0xA364
			#define CHUNK3DS_MATERIAL_RGB_TINT_G		0xA366
			#define CHUNK3DS_MATERIAL_RGB_TINT_B		0xA368


		#define CHUNK3DS_MATERIAL_MASK_TEXTURE1				0xA33E
		#define CHUNK3DS_MATERIAL_MASK_TEXTURE2				0xA340
		#define CHUNK3DS_MATERIAL_MASK_OPACITY				0xA342
		#define CHUNK3DS_MATERIAL_MASK_BUMP					0xA344
		#define CHUNK3DS_MATERIAL_MASK_SHININESS			0xA346
		#define CHUNK3DS_MATERIAL_MASK_SPECULAR				0xA348
		#define CHUNK3DS_MATERIAL_MASK_SELFILLUM			0xA34A
		#define CHUNK3DS_MATERIAL_MASK_REFLECTION			0xA34C



	#define CHUNK3DS_KEYF					0xB000
		#define CHUNK3DS_KEYF_AMBIENT			0xB001
		#define CHUNK3DS_KEYF_MESH				0xB002
			#define CHUNK3DS_KEYF_OBJECT_NAME		0xB010 
			#define CHUNK3DS_KEYF_OBJECT_PIVOT		0xB013 
			#define CHUNK3DS_KEYF_TRACK_POSITION	0xB020 
			#define CHUNK3DS_KEYF_TRACK_ROTATION	0xB021 
			#define CHUNK3DS_KEYF_TRACK_SCALE		0xB022
			#define CHUNK3DS_KEYF_TRACK_MORPH		0xB026 
			#define CHUNK3DS_KEYF_TRACK_HIDE		0xB029 
			#define CHUNK3DS_KEYF_TRACK_HIERARCHY	0xB030 
		#define CHUNK3DS_KEYF_CAMERA			0xB003
			#define CHUNK3DS_KEYF_TRACK_FOV			0xB023 
			#define CHUNK3DS_KEYF_TRACK_ROLL		0xB024 
		#define CHUNK3DS_KEYF_CAMERA_INFO		0xB004 
		#define CHUNK3DS_KEYF_OMNI_LIGT			0xB005 
		#define CHUNK3DS_KEYF_SPOT_LIGHT_TARGET 0xB006 
		#define CHUNK3DS_KEYF_SPOT_LIGHT		0xB007 
		#define CHUNK3DS_KEYF_FRAMES			0xB008 
		#define CHUNK3DS_KEYF_OBJECT_MORPH		0xB015 
		#define CHUNK3DS_KEYF_TRACK_COLOR		0xB025 
		#define CHUNK3DS_KEYF_TRACK_HOTSPOTH	0xB027 
		#define CHUNK3DS_KEYF_TRACK_FALLOFF		0xB028 

#define CHUNK3DS_BIT_MAP			0x1100
#define CHUNK3DS_USE_BIT_MAP		0x1101
#define CHUNK3DS_V_GRADIENT			0x1300
#define CHUNK3DS_USE_V_GRADIENT		0x1301
#define CHUNK3DS_LO_SHADOW_BIAS		0x1400
#define CHUNK3DS_HI_SHADOW_BIAS		0x1410
#define CHUNK3DS_SHADOW_MAP_SIZE	0x1420
#define CHUNK3DS_SHADOW_SAMPLES		0x1430
#define CHUNK3DS_SHADOW_RANGE		0x1440
#define CHUNK3DS_SHADOW_FILTER		0x1450
#define CHUNK3DS_RAY_BIAS			0x1460
#define CHUNK3DS_RAY_SHADOWS		0x1470
#define CHUNK3DS_O_CONSTS			0x1500
#define CHUNK3DS_AMBIENT_LIGHT		0x2100
#define CHUNK3DS_FOG				0x2200
#define CHUNK3DS_USE_FOG			0x2201
#define CHUNK3DS_FOG_BGND			0x2210
#define CHUNK3DS_DISTANCE_CUE		0x2300
#define CHUNK3DS_USE_DISTANCE_CUE	0x2301
#define CHUNK3DS_LAYER_FOG			0x2302
#define CHUNK3DS_USE_LAYER_FOG		0x2303
#define CHUNK3DS_DCUE_BGND			0x2310
#define CHUNK3DS_N_D_L_OLD			0x4400
#define CHUNK3DS_N_CAM_OLD			0x4500
#define CHUNK3DS_N_AMBIENT_LIGHT	0x4680
#define CHUNK3DS_POLY_2D			0x5000



#endif

#endif /* DOXYGEN_SHOULD_SKIP_THIS */
