#ifndef _MISTSERVER_H_
#define _MISTSERVER_H_

#include <vector>

#include "../zerofpsv2/engine/application.h"
#include "../zerofpsv2/gui/zgui.h"
#include "guiserverinfo.h"
#include "../zerofpsv2/engine/entitymanager.h"

class Camera;
class Entity;







//const string CREATED_SCRIPTS_DIR = "data/script/custom_scripts/";

/**	\brief	Da ZeroEd
		\ingroup ZeroEd
*/ 
class ZeroEd :public Application , public ZGuiApp {
	private:

		//console funktions
		enum FuncId_e
		{
			FID_NEW,
			FID_LOAD,
			FID_SAVE,
			FID_SAVEAS,
			FID_USERS,
			FID_LOCALORDER,
			FID_LIGHTMODE,
			FID_EDITSUN,

			FID_RECREATE,
			
			FID_SETCAM,
			FID_CAMLINK,
			FID_CAMSOLO,
			FID_CAMGRID,
			FID_SELNONE,
			FID_GRIDSIZE,
			FID_GRIDAUTOSNAP,
			FID_GRIDSNAP,
			FID_CAMFOLLOW,
			FID_CAMNOFOLLOW,
			FID_DELETE,
			FID_CLONE,
			FID_CUT,
			FID_COPY,
			FID_PASTE,

			FID_SNAPSAVE,
			FID_SNAPLOAD,
			FID_TEST_JIDDRA,		// Owned by Vim.
			FID_SNAPSIZE,
			FID_FINDENT,
		};
			
		enum EditMode_e
		{
			EDIT_ZONES,
			EDIT_OBJECTS,
			EDIT_HMAP,
			EDIT_MAX,
			EDIT_AMBIENTSOUNDS,
			EDIT_ENVIROMENTS,		
		};

		enum GUISelectFileWndState_e
		{
			NONE = 0,
			SELECT_SOUND,
			SELECT_MAD,
		};

		enum ZoneCorners
		{ 
			eNone=0, 
			eTopLeft, 
			eTop, 
			eTopRight, 
			eRight, 
			eBottomRight, 
			eBottom, 
			eBottomLeft, 
			eLeft 
		};

		enum HMapEditMode
		{
			HMAP_EDITVERTEX,
			HMAP_DRAWSMFLAT,
			HMAP_DRAWMASK,
			HMAP_DRAWVISIBLE,
			HMAP_MAX,
		};


		//wierd stuff
		char		szCoolName[256];
		string	strMasterSmiley;

		// zone and object edit
		bool		m_bPlaceObjectsOnGround;
		int		m_iAutoSnapZoneCorner; // -1 = dont use

		// gui stuff
		int		m_iSelectFileState;		
		Entity*	m_pkPreviewEntity;
		vector<GUIServerInfo> m_vkServerList;
		
		string	m_strWorldDir;						// The current dir for the world. Use for SaveAs and Title.

		//
		bool	m_bRemoteEditing;
		
		//delay
		float	m_fDelayTime;

		// snapsize
		Vector3	m_kSnapSize;
		Vector3 m_kSnapOffset;

		// camera->marker distance
		float	m_fZoneMarkerDistance;
		float	m_fObjectMarkerDistance;
		
		//edit sun
		bool 			m_bEditSun;
		//LightSource	m_kSun;				
		
		//edit stuff
		int		m_iEditMode;
		int		m_iHMapEditMode;

		//camera
		Entity*	m_pkCameraObject[4];
		Camera*	m_pkCamera[4];
		Entity*	m_pkActiveCameraObject;
		Camera*	m_pkActiveCamera;
		bool		m_bSoloMode;
		float 	m_CamMoveSpeed;		
		string	m_strActiveViewPort;		//active view port
		bool		m_bPlaneMovement;

		//zone data
		string	m_strActiveZoneName;		
		string	m_strActiveEnviroment;		
		Vector3	m_kZoneSize;
		Vector3	m_kZoneMarkerPos;
		Vector3	m_kZoneModelRotation;
		Vector3  m_kLastZonePos;
		Vector3  m_kLastZoneSize;
		
		Entity*	m_pkZoneMarkerEntity;
		
		//entity data
		string	m_strActiveObjectName;		
		Vector3	m_kObjectMarkerPos;
		int		m_iCurrentObject;
		int 		m_iCurrentMarkedZone;
		
		//physics stuff
		Vector3	m_kLocalGrabPos;
		Vector3	m_kGrabPos;
		Vector3	m_kGrabCurrentPos;
		int		m_iGrabEntity;
		float		m_fArmLength;
		bool		m_bGrabing;

		//graphs
		DebugGraph m_kTestGraph;
				
		//selected entitys
		set<int>	m_SelectedEntitys;
		
		//heightmap stuff
		Vector3						m_kDrawPos;
		vector<HMSelectVertex>	m_kSelectedHMVertex;
		float 						m_fHMInRadius;
		float 						m_fHMOutRadius;
		int							m_iEditLayer;

		//network
		vector<ZoneData>			m_kNetworkZones;
		string		m_strLoginName, m_strLoginPW;
								
		//consolecommand handle
		void EditRunCommand(FuncId_e eEditCmd);
		
		// zone and object edit
		bool PlaceObjectOnGround(int iObjectID, int iZoneID);
		bool PlaceObjectOnGround(int iObjectID);
		
		//gui stuff...or something 
		void FillPropertyValList();
		bool FillPropertyList();
		bool UpdatePropertyList(int iID);		
		void SetupPreviewWnd(const char* szMadFile);
		void UpdatePreviewObject();
		void OpenObjectMenu();
		void InitMainMenu();
		void GUIFillServerList();
		void OnGUIAddServer(bool bAdd);
		void AddLoadFoldersToMenu();

		//camera stuff
		void  CreateEditCameras();
		bool 	SetCamera(int iNum);
		int	GetView(float x, float y);
		void 	CamFollow(bool bFollowMode);


		// Selection of Entitys.
		void	Select_None(	)				{ m_SelectedEntitys.clear(); }
		void	Select_Add( int iId )		{ m_SelectedEntitys.insert(iId); }
		void	Select_Remove( int iId )	{ m_SelectedEntitys.erase(iId); }
		void	DrawSelectedEntity();
		void	Select_Toggle(int iId, bool bMultiSelect);


		//picking
		Vector3	Get3DMouseDir(bool bMouse);
		Entity*	GetTargetObject();		
		Entity*	GetTargetObject2();		
		int		GetTargetTCS(Vector3* pkPos);		
				
		int			GetZoneID(const Vector3& kPos);
		ZoneData*	GetZoneData(int iZoneID);
		ZoneData*	GetZoneByEntityID(int iEntityID);
		
		//enviroment
		string 	GetZoneEnviroment();
		char* 	GetSelEnviromentString();
		
		void	UpdateModelMarker(Vector3 kPos,bool bEnabled);
		void	UpdateZoneMarkerPos();
		Vector3 GetZonePosAutoSnap();
		void	UpdateObjectMakerPos();
		void	DrawZoneMarker(Vector3 kPos);
		void	DrawCrossMarker(Vector3 kPos);

		void	SetupGuiEnviroment();
		void	ToogleLight();

		//heightmap
		HeightMap*	SetPointer();
		void			DrawHMEditMarker(Vector3 kCenterPos, float fInRadius, float fOutRadius );
		void			HMModifyCommand(float fSize);

		//input
		void 	Input_Camera(float fMouseX, float fMouseY);
		void 	Input_EditTerrain();
		void 	Input_EditZone();
		void 	Input_EditObject(float fMouseX, float fMouseY);		
		void	Input_EditAmbientSounds();
		bool	DelayCommand();			//make a delay
		
		//network
		void	SendSetZoneModel(string strModel,int iZoneID);
		void	SendSetZoneEnviroment(string strEnviroment,int iZoneID);
		void	SendRotateZoneModel(int iZoneID);
		void	SendZoneListRequest();
		void	SendDeleteSelected();			// Removes selected entitys.
		void	AddSelected(NetPacket* pkNetPack);	// Add id's of selected entitys to packet.
		void	SendAddZone(Vector3 kPos, Vector3 kSize, Vector3 kModelRot, string strName);		
		void	SendRotateEntity(int iEntityID,const Vector3& kRot);
		void	SendAction(int iEntityID,const string& strAction);
		
		vector<HMSelectVertex> GetAllSelectedHMVertex();

	public:
		bool SetViewPort(const char* szVpName);

		void OnClickTabPage(ZGuiTabCtrl *pkTabCtrl, int iNewPage, int iPrevPage);
		void OnClickListbox( int iListBoxID, int iListboxIndex, ZGuiWnd* pkMain);
		void OnCommand(int iID, bool bRMouseBnClick, ZGuiWnd* pkMainWnd);
		void OnKeyPress(int iID, ZGuiWnd* pkWnd);
		
		void OnClickTreeItem(char *szTreeBox, char *szParentNodeText, 
									char *szClickNodeText, bool bHaveChilds);
		
		ZeroEd(char* aName,int iWidth,int iHeight,int iDepth);
	 	
	 	void OnInit();
		void OnIdle();
		void OnHud();
		void OnSystem();
				
		void RunCommand(int cmdid, const CmdArgument* kCommand);		
		void Init();
		void RegisterPropertys();
		void RegisterResources();		
		void Input();
		void OnServerStart();
		void OnClientStart();
		void OnClientConnected();

		void AddPropertyVal();
		void AddProperty(int iEntityID,const string& strProperty);
		void RemoveSelProperty();
      bool SaveCurrentToScript();
	
		//on client join, server runs this
		bool OnPreConnect(IPaddress, char*, char*, bool bIsEditor, string& strWhy){return true;}
		void OnServerClientJoin(ZFClient*,int, char*, char*, bool bIsEditor){};
		void OnServerClientPart(ZFClient* pkClient,int iConID){};
		void RenderInterface(void);
		void OnNetworkMessage(NetPacket *PkNetMessage);
		void OnDisconnect(int iConnectionID);

		void AutoSetZoneSize(string strName);
		void SoloToggleView();


		bool StartUp()		{ return true; }
		bool ShutDown()	{ return true; }
		bool IsValid()		{ return true; }

		//void SendAppMessage(NetPacket* pkNet);

};



#endif


