#ifndef _KEYS_H_
#define _KEYS_H_


/*
	This is the input keys from the keyboard. They are mapped as far as possible to map to ASCII.
*/

enum Key_Modifiers
{
	MODIFIER_ALT	= 1,
	MODIFIER_CTRL	= 8,
	MODIFIER_SHIFT = 16,
	MODIFIER_META	= 32,
};

enum Buttons
{
	KEY_BACKSPACE	= 8,		
	KEY_TAB			= 9,				
	// Clear			
	KEY_RETURN		= 13,			
	//PAUSE
	KEY_ESCAPE		= 27,			
	KEY_SPACE		= 32,	
	KEY_EXCLAIM		= 33,				
	KEY_QUOTEDBL	= 34,				
	KEY_HASH			= 35,				
	KEY_DOLLAR		= 36,				
	KEY_AMPERSAND	= 38,				
	KEY_QUOTE		= 39,			
	KEY_LEFTPAREN	= 40,				
	KEY_RIGHTPAREN	= 41,				
	KEY_ASTERISK	= 42,				
	KEY_PLUS			= 43,		
	KEY_COMMA		= 44,				
	KEY_MINUS		= 45,			
	KEY_PERIOD		= 46,				
	KEY_SLASH		= 47,				

	KEY_0				= 48,				
	KEY_1				= 49,				
	KEY_2				= 50,			
	KEY_3				= 51,			
	KEY_4				= 52,			
	KEY_5				= 53,			
	KEY_6				= 54,			
	KEY_7				= 55,				
	KEY_8				= 56,			
	KEY_9				= 57,				
	
	KEY_COLON		= 58,			
	KEY_SEMICOLON	= 59,			
	KEY_LESS			= 60,				
	KEY_EQUALS		= 61,				
	KEY_GREATER		= 62,				
	KEY_QUESTION	= 63,			
	KEY_AT			= 64,				

	KEY_LEFTBRACKET	= 91,			
	KEY_BACKSLASH		= 92,				
	KEY_RIGHTBRACKET	= 93,			
	KEY_CARET			= 94,				
	KEY_UNDERSCORE		= 95,				
	KEY_BACKQUOTE		= 96,


	KEY_A					= 97,				
	KEY_B					= 98,					
	KEY_C					= 99,				
	KEY_D					= 100,		
	KEY_E					= 101,			
	KEY_F					= 102,		
	KEY_G					= 103,		
	KEY_H					= 104,			
	KEY_I					= 105,					
	KEY_J					= 106,				
	KEY_K					= 107,				
	KEY_L					= 108,				
	KEY_M					= 109,			
	KEY_N					= 110,			
	KEY_O					= 111,		
	KEY_P					= 112,				
	KEY_Q					= 113,			
	KEY_R					= 114,				
	KEY_S					= 115,				
	KEY_T					= 116,				
	KEY_U					= 117,			
	KEY_V					= 118,				
	KEY_W					= 119,				
	KEY_X					= 120,			
	KEY_Y					= 121,					
	KEY_Z					= 122,				
	// End Of Evil Ascii.


	/* Num Keypad */
	KEY_KP0,
	KEY_KP1,
	KEY_KP2,
	KEY_KP3,
	KEY_KP4,
	KEY_KP5,
	KEY_KP6,
	KEY_KP7,
	KEY_KP8,
	KEY_KP9,
	KEY_KP_PERIOD,				
	KEY_KP_DIVIDE,			
	KEY_KP_MULTIPLY,			
	KEY_KP_MINUS,				
	KEY_KP_PLUS,				
	KEY_KP_ENTER,				
	KEY_KP_EQUALS,				

	/* Arrow Pad */
	KEY_LEFT,			
	KEY_RIGHT,			
	KEY_UP,				
	KEY_DOWN,	

	/* Ins/Home/Page Pad*/
	KEY_PAGEUP,			
	KEY_PAGEDOWN,		
	KEY_HOME,			
	KEY_END,			
	KEY_DELETE,		
	KEY_INSERT,		

	/* Function keys */
	KEY_F1,				
	KEY_F2,				
	KEY_F3,				
	KEY_F4,				
	KEY_F5,				
	KEY_F6,				
	KEY_F7,				
	KEY_F8,				
	KEY_F9,			
	KEY_F10,				
	KEY_F11,				
	KEY_F12,				
	KEY_F13,				
	KEY_F14,				
	KEY_F15,				

	KEY_NUMLOCK,			
	KEY_CAPSLOCK,				
	KEY_SCROLLLOCK,	
	KEY_RSHIFT,		
	KEY_LSHIFT,			
	KEY_RCTRL,		
	KEY_LCTRL,			
	KEY_RALT,		
	KEY_LALT,			


	

	//mouse
	MOUSELEFT=397,
	MOUSEMIDDLE,
	MOUSERIGHT,
	MOUSEWUP,
	MOUSEWDOWN,

	//joystick 0
	JOYSTICK0_BUTTON0=500,
	JOYSTICK0_BUTTON1,	
	JOYSTICK0_BUTTON2,	
	JOYSTICK0_BUTTON3,	
	JOYSTICK0_BUTTON4,	
	JOYSTICK0_BUTTON5,	
	JOYSTICK0_BUTTON6,	
	JOYSTICK0_BUTTON7,	
	JOYSTICK0_BUTTON8,	
	JOYSTICK0_BUTTON9,	

	JOYSTICK0_AXIS0_MIN,	
	JOYSTICK0_AXIS0_MAX,	
	JOYSTICK0_AXIS1_MIN,	
	JOYSTICK0_AXIS1_MAX,	
	
	//joystick 1
	JOYSTICK1_BUTTON0=520,
	JOYSTICK1_BUTTON1,	
	JOYSTICK1_BUTTON2,	
	JOYSTICK1_BUTTON3,	
	JOYSTICK1_BUTTON4,	
	JOYSTICK1_BUTTON5,	
	JOYSTICK1_BUTTON6,	
	JOYSTICK1_BUTTON7,	
	JOYSTICK1_BUTTON8,	
	JOYSTICK1_BUTTON9,	

	JOYSTICK1_AXIS0_MIN,	
	JOYSTICK1_AXIS0_MAX,	
	JOYSTICK1_AXIS1_MIN,	
	JOYSTICK1_AXIS1_MAX,	
	
	
	//joystick 2
	JOYSTICK2_BUTTON0=540,
	JOYSTICK2_BUTTON1,	
	JOYSTICK2_BUTTON2,	
	JOYSTICK2_BUTTON3,	
	JOYSTICK2_BUTTON4,	
	JOYSTICK2_BUTTON5,	
	JOYSTICK2_BUTTON6,	
	JOYSTICK2_BUTTON7,	
	JOYSTICK2_BUTTON8,	
	JOYSTICK2_BUTTON9,	

	JOYSTICK2_AXIS0_MIN,	
	JOYSTICK2_AXIS0_MAX,	
	JOYSTICK2_AXIS1_MIN,	
	JOYSTICK2_AXIS1_MAX,	
	
	
	//joystick 3
	JOYSTICK3_BUTTON0=540,
	JOYSTICK3_BUTTON1,	
	JOYSTICK3_BUTTON2,	
	JOYSTICK3_BUTTON3,	
	JOYSTICK3_BUTTON4,	
	JOYSTICK3_BUTTON5,	
	JOYSTICK3_BUTTON6,	
	JOYSTICK3_BUTTON7,	
	JOYSTICK3_BUTTON8,	
	JOYSTICK3_BUTTON9,	

	JOYSTICK3_AXIS0_MIN,	
	JOYSTICK3_AXIS0_MAX,	
	JOYSTICK3_AXIS1_MIN,	
	JOYSTICK3_AXIS1_MAX,	
			
};









#endif

