// ZGuiSkin.h: interface for the ZGuiSkin class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _BASIC_ZGUISKIN_H_
#define _BASIC_ZGUISKIN_H_

#include "basic_x.h"
#include "rect.h"

class ZIFAnimation;

class BASIC_API ZGuiSkin  
{
public:

	//ZGuiSkin(ZGuiSkin* pkSkin)

	const ZGuiSkin& operator=(const ZGuiSkin& pkSkinSrc );

	bool ZGuiSkin::operator==(ZGuiSkin d);

	ZGuiSkin(ZGuiSkin* pkCopy);	

	// Everything : 17 parameters
	ZGuiSkin(int t1,int t2,int t3,int t4,	// Textures
			 int a1,int a2,int a3,int a4,	// Alpha Textures
			 int r1,int g1,int b1,			// Background color
			 int r2,int g2,int b2,			// Border color
			 int bsz,bool tile_texture,		// Border size, tile textures.
			 bool transparent);				// Transparent background

	// Only textures : 10 parameters
	ZGuiSkin(int t1,int t2,int t3,int t4,	// Textures
			 int a1,int a2,int a3,int a4,	// Alpha Textures
			 int bsz, bool tile_texture);	// Border size, tile textures.

	// Only colors and transparence: 8 parameters
	ZGuiSkin(int r1,int g1,int b1,			// Background color
	  		 int r2,int g2,int b2,			// Border color
			 int bsz, bool bTransparent);	// Border size

	// Only colors: 7 parameters
	ZGuiSkin(int r1,int g1,int b1,			// Background color
	  		 int r2,int g2,int b2,			// Border color
			 int bsz);						// Border size

	// Only textures, no alpha : 5 parameters
	ZGuiSkin(int t1,int t2,int t3,int t4,	// Textures
			 bool tile_texture);			// Tile textures.

	// Only bk texture, no alpha : 3 parameter
	ZGuiSkin(int t1,						// Textures
			 int a1,						// Alpha Textures
			 bool tile_texture);			// Tile textures.

	// Only bk texture, no alpha : 2 parameter
	ZGuiSkin(int t1,						// Textures
			 bool tile_texture);			// Tile textures.

	// Default : 0 parameter
	ZGuiSkin();								

	~ZGuiSkin() {}

	Rect m_rcBkTile; // Right = Width, Bottom = Height. U

	long m_iBkTexID;			// -1 innebr att det inte finns nn textur.
	long m_iHorzBorderTexID;	// -1 innebr att det inte finns nn textur.
	long m_iVertBorderTexID;	// -1 innebr att det inte finns nn textur.
	long m_iBorderCornerTexID;	// -1 innebr att det inte finns nn textur.

	long m_iBkTexAlphaID;			// -1 innebr att det inte finns nn textur.
	long m_iHorzBorderTexAlphaID;	// -1 innebr att det inte finns nn textur.
	long m_iVertBorderTexAlphaID;	// -1 innebr att det inte finns nn textur.
	long m_iBorderCornerTexAlphaID;	// -1 innebr att det inte finns nn textur.

	float m_afBkColor[3];
	float m_afBorderColor[3];
	float m_fRotDegree;

	unsigned short m_unBorderSize; // Bredden och hjden p ramen kring fnstret.
	unsigned char m_ucRots90Degree; // Hur mnga gngen texturen skall roteras t vnster (0,1,2 eller 3)
	bool m_bTileBkSkin;

	bool m_bTransparent; // andvnds bla. av labels som inte skall ha nn bakgrundsfrg.
	bool m_bHaveAlpha; // om det r en TGA eller en bmp med alpha textur

	void SetAnimation(char* szName, int iMode, int iOptions, bool bPlay);

	ZIFAnimation* m_pkZIFAnimation;
};

#endif







