uniform sampler2D g_kTexture0;
uniform sampler2D g_kTexture1;
uniform sampler2D g_kTexture2;
uniform sampler2D g_kTexture3;

uniform vec3 g_kEyePosition;
uniform int  g_iActiveLights;


varying vec3 kNormal;
varying vec3 kVertex;



void main (void)
{
	vec4 tex = texture2D(g_kTexture0,gl_TexCoord[0].st); 

	//shadow alpha
  	float s = texture2D(g_kTexture3,gl_TexCoord[3].st).a;


	float fAttenuation;
	float fDistance;
	vec3	kLightDir;
	vec4	kAmbient;
	vec4	kDiffuse;

	vec4 shadowdif;
	vec4 shadowamb;
	vec4 color = vec4(0,0,0,1);
	vec4 shadow = vec4(0,0,0,1);

	//shadow light
	kLightDir = normalize(gl_LightSource[0].position).xyz;
	shadowamb = gl_LightSource[0].ambient;
 	shadowdif = max(dot(kLightDir,kNormal),0)*gl_LightSource[0].diffuse;

// 	int i = 1;
// 	while(i < g_iActiveLights)
// 	{
	for(int i = 0;i<8;i++)
	{
		if(i<g_iActiveLights)
		{

			//point light
			fDistance = distance(gl_LightSource[i].position.xyz,kVertex);
	
			//point or directional light?
			fAttenuation = (1/(gl_LightSource[i].constantAttenuation + 
									gl_LightSource[i].linearAttenuation*fDistance + 
									gl_LightSource[i].quadraticAttenuation*(fDistance*fDistance)));
			
	
			kLightDir = normalize(gl_LightSource[i].position - kVertex);				
			kAmbient = gl_LightSource[i].ambient * fAttenuation;
			kDiffuse = dot(kLightDir,kNormal)*gl_LightSource[i].diffuse * fAttenuation;
	
			color += clamp(kAmbient+kDiffuse,0,1);

		}
	}

  	shadow = color + shadowamb + shadowdif*0.1;
 	color += shadowamb+shadowdif;
// 	
//  	shadow *= gl_Color;
//  	color *= gl_Color;

  	shadow.a = gl_Color.a;
 	color.a = gl_Color.a;

 	shadow = clamp(shadow,0,1);
 	color = clamp(color,0,1);

//  	tex *=  ( (color*(1-s) )+(shadow*s) );

   	tex *= shadow *  (1-s);
//  	tex.a = texture2D(g_kTexture3,gl_TexCoord[3].st).a;
//  	tex.xyz = texture2D(g_kTexture3,gl_TexCoord[3].st).a;

 
	//apply fog
	float fog = clamp((gl_Fog.end - gl_FogFragCoord) / (gl_Fog.end - gl_Fog.start),0,1);
 	tex.xyz= (1-fog)*gl_Fog.color.xyz + fog*tex.xyz;


 	gl_FragColor = tex;
}
