function Create()
	InitObject();
	SetReturnObject();
		InitProperty("P_Mad");
			InitParameter("m_kMadFile","/data/mad/villager_woman.mad");
			InitParameter("m_iShadowGroup","4");
			
		InitProperty("P_Ml");
		
	AddAction(GetSelfID(),"Restart");
	AddAction(GetSelfID(),"Rules");
	AddAction(GetSelfID(),"Take 3 sticks");
	AddAction(GetSelfID(),"Take 2 sticks");
	AddAction(GetSelfID(),"Take 1 stick");

	SetLocalDouble(GetSelfID(), "m_iSticks", 0);
	SetLocalDouble(GetSelfID(), "m_iWon", 0);
	SetLocalDouble(GetSelfID(), "m_iLost", 0);
end

-----------------------------------------------------------------------------

function Useit( Character ,Action )
	if Action == "Restart" then
		RestartGame(Character);
	end

	if Action == "Rules" then
		SayToCharacter(Character,"Stick women: I have 20 sticks. On each turn we take 1 to 3 sticks. You win if I take the last stick.");
	end

	if Action == "Take 3 sticks" then
		TakeSticks(Character,3,1);
	end

	if Action == "Take 2 sticks" then
		TakeSticks(Character,2,1);
	end

	if Action == "Take 1 stick" then
		TakeSticks(Character,1,1);
	end
		
end

-----------------------------------------------------------------------------

function StickAI(Character)
	iSticksLeft = GetLocalDouble(GetSelfID(), "m_iSticks");
	
	-- test which move is best
	Score1 = TestMove(1, iSticksLeft, -1);
	Score2 = TestMove(2, iSticksLeft, -1);
	Score3 = TestMove(3, iSticksLeft, -1);
	
	if Score1 > 0 then
		iNrSticks = 1
	elseif Score2 > 0 then
		iNrSticks = 2
	else
		iNrSticks = 3
	end
	
	--buggfix, if woman is about to lose, she tries to take 3 sticks even if it's an elegal move
	if iNrSticks > iSticksLeft then
		iNrSticks = 1;
	end

	SayToCharacter(Character, "Stick women: I took " .. iNrSticks .. " sticks.");
	TakeSticks (Character,iNrSticks, 0);	
end

-----------------------------------------------------------------------------

function CheckWin( Character, player )
	if GetLocalDouble(GetSelfID(), "m_iSticks") == 0 then
		if player == 1 then
			SetLocalDouble(GetSelfID(), "m_iWon", GetLocalDouble(GetSelfID(), "m_iWon")+1);
			SayToCharacter(Character,"Stick women: You lost! You took the last stick. I won for the " .. GetLocalDouble(GetSelfID(), "m_iWon") .. " time.");	
		else
			SetLocalDouble(GetSelfID(), "m_iLost", GetLocalDouble(GetSelfID(), "m_iLost")+1);
			SayToCharacter(Character,"Stick women: You won for the " .. GetLocalDouble(GetSelfID(), "m_iLost") .. " time! I took the last stick, you outwitted me!");
		end

		return 1;	
	end
	
	return 0;
end

-----------------------------------------------------------------------------

function TakeSticks( Character, nr, player )
	if GetLocalDouble(GetSelfID(), "m_iSticks") == 0 then
		SayToCharacter(Character,"Stick women: Oh, you want to do the game again?");
		RestartGame(Character);
		return;
	end

	if nr > GetLocalDouble(GetSelfID(), "m_iSticks") then
		SayToCharacter(Character,"Stick women: There aren't that many sticks left.");
		return;
	end

	SetLocalDouble(GetSelfID(), "m_iSticks", GetLocalDouble(GetSelfID(), "m_iSticks") - nr);

	if player == 0 then
		SayToCharacter(Character, "Stick women: There are " .. GetLocalDouble(GetSelfID(), "m_iSticks") .. " sticks left.");
	end

	if CheckWin( Character, player ) == 0 and player == 1 then
		StickAI(Character);
	end

end

-----------------------------------------------------------------------------

function RestartGame(Character)
	WhoStarts = Random(2);
	
	SetLocalDouble(GetSelfID(), "m_iSticks", 20);
	
	if WhoStarts == 0 then
		SayToCharacter(Character,"Stick women: Ok, we'll restart the game. There are 20 sticks left. It's you turn.");
	else
		SayToCharacter(Character,"Stick women: Ok, we'll restart the game. There are 20 sticks left. I'll start.");
		StickAI(Character);
	end

end

-----------------------------------------------------------------------------
function TestMove (StickNr, SticksLeft, WhosTurn)

	if WhosTurn == -1 then
		WhosTurn = 1;
	else
		WhosTurn = -1;
	end

	if SticksLeft - StickNr < 5 and SticksLeft - StickNr > 1 or SticksLeft - StickNr < 1 then 	    --player lost
		return -1 * WhosTurn;
	elseif SticksLeft - StickNr == 1 then
		return 1 * WhosTurn;
	else

		Result = TestMove(1, SticksLeft - StickNr, WhosTurn);
		Result = Result + TestMove(2, SticksLeft - StickNr, WhosTurn);
		Result = Result + TestMove(3, SticksLeft - StickNr, WhosTurn);
	end

	return Result;
end
