-- This is a elevator that moves between two positions. The first one is were is it put and the second one
-- is distance units up (down if distance is negative). Moves in speed and waits at the second position for
-- delay seconds. If delay is -1 then it waits until activaded again. 

function Create()
	InitObject();
	SetParentObject();
	SetReturnObject();
	
		InitProperty("P_Mad");	
			InitParameter("m_kMadFile","/data/mad/galler.mad");
			InitParameter("m_fScale",2);
		
		InitProperty("P_Tcs");
			InitParameter("testtype","1");
			InitParameter("static","false");
			InitParameter("group",0);	
			InitParameter("mass",9999999);
			InitParameter("bounce",0);				
			InitParameter("activemoment","false");

		InitProperty("P_Ml");			
			
	AddAction(GetSelfID(),"Use")
		
	SetLocalDouble(GetSelfID(), "fDistance", 2.5);	
	SetLocalDouble(GetSelfID(), "fSpeed", 2);	
	SetLocalDouble(GetSelfID(), "fWait", 5);	

	SetLocalVector(GetSelfID(), "m_kStart", 0,0,0);		
	SetLocalVector(GetSelfID(), "m_kEnd", 0,0,0);		
	SetLocalDouble(GetSelfID(), "m_iState", 0);
	

	-- 0: at start, 1: moving to end , 2: at end
end


function Useit( Character,Action )
	if Action == "Use" then

		iState = GetLocalDouble(GetSelfID(), "m_iState");
		
		if iState == 0 then 
			kPos = GetObjectPos( GetSelfID() );
			SetLocalVector(GetSelfID(), "m_kStart", kPos[1],kPos[2],kPos[3]);		
		
			fDistance = GetLocalDouble(GetSelfID(), "fDistance");	
			kPos[2] = kPos[2] + fDistance;
			SetLocalVector(GetSelfID(), "m_kEnd", kPos[1],kPos[2],kPos[3]);				
			
			SetLocalDouble(GetSelfID(), "m_iState", 1);
			
			SetHeartRate(GetSelfID(), 0);
		end
	end
end


function HeartBeat()
	iState = GetLocalDouble(GetSelfID(), "m_iState");
	fDistance = GetLocalDouble(GetSelfID(), "fDistance");	
	fWait = GetLocalDouble(GetSelfID(), "fWait");	
	fSpeed = GetLocalDouble(GetSelfID(), "fSpeed");
	
	kPos    = GetObjectPos( GetSelfID() );
	kEnd    = GetLocalVector(GetSelfID(), "m_kEnd");	
	kStart  = GetLocalVector(GetSelfID(), "m_kStart");	
	
	
			
	--check if standing still
	if iState == 0 then
		SetHeartRate(GetSelfID(), -1);
		return;
	end
	
	--moving up
	if iState == 1 then
		if fDistance > 0 then	
			--end is up
			if kPos[2] > kEnd[2] then
				--stop elevator and set new state
				vel = {3};
				vel[1] = 0;
				vel[2] = 0;
				vel[3] = 0;
				SetLinVel(GetSelfID(),vel);				
				
				SetObjectPos(GetSelfID(),kEnd);
				
				SetLocalDouble(GetSelfID(), "m_iState", 2);
				SetHeartRate(GetSelfID(), fWait);
				return;
			else
				vel = {3};
				vel[1] = 0;
				vel[2] = fSpeed;
				vel[3] = 0;
				SetLinVel(GetSelfID(),vel);		
			end
		else
			--end is down
			if kPos[2] < kEnd[2] then
				--stop elevator and set new state
				vel = {3};
				vel[1] = 0;
				vel[2] = 0;
				vel[3] = 0;
				SetLinVel(GetSelfID(),vel);				
				
				SetObjectPos(GetSelfID(),kEnd);
				
				SetLocalDouble(GetSelfID(), "m_iState", 2);
				SetHeartRate(GetSelfID(), fWait);
				return;
			else
				vel = {3};
				vel[1] = 0;
				vel[2] = -fSpeed;
				vel[3] = 0;
				SetLinVel(GetSelfID(),vel);		
			end
		end		
	end
	
	
	--start moving back to start
	if iState == 2 then
		--moving up
		if fDistance > 0 then
			if kPos[2] < kStart[2] then
				--stop elevator and set new state
				vel = {3};
				vel[1] = 0;
				vel[2] = 0;
				vel[3] = 0;
				SetLinVel(GetSelfID(),vel);				
				
				SetLocalDouble(GetSelfID(), "m_iState", 0);
				SetHeartRate(GetSelfID(), -1);
				return;
			else
				vel = {3};
				vel[1] = 0;
				vel[2] = -fSpeed;
				vel[3] = 0;
				SetLinVel(GetSelfID(),vel);
				SetHeartRate(GetSelfID(), 0);		
			end
			
		--moving down
		else
			if kPos[2] > kStart[2] then
				--stop elevator and set new state
				vel = {3};
				vel[1] = 0;
				vel[2] = 0;
				vel[3] = 0;
				SetLinVel(GetSelfID(),vel);				
				
				SetLocalDouble(GetSelfID(), "m_iState", 0);
				SetHeartRate(GetSelfID(), -1);
				return;
			else
				vel = {3};
				vel[1] = 0;
				vel[2] = fSpeed;
				vel[3] = 0;
				SetLinVel(GetSelfID(),vel);
				SetHeartRate(GetSelfID(), 0);		
			end
		end
	end
end