uniform sampler2D g_kTexture0;
uniform sampler2D g_kTexture1;
uniform sampler2D g_kTexture2;
uniform sampler2D g_kTexture3;


void main (void)
{
	//get texture
  	vec4 c1 = texture2D(g_kTexture0,gl_TexCoord[0].st);

	//shadow alpha
  	float s = texture2D(g_kTexture3,gl_TexCoord[3].st).a;
  	
	s*= 0.25;
	

	//get interpolated shadow/lit color
 	vec4 color = c1 *  gl_Color*(1-s);

	//apply fog
	float f = clamp((gl_Fog.end - gl_FogFragCoord) / (gl_Fog.end - gl_Fog.start),0,1);
	color.xyz= (1-f)*gl_Fog.color.xyz + f*color.xyz;

	//writeout color
	gl_FragColor = color ;
}
