uniform sampler2D g_kTexture0;
uniform sampler2D g_kTexture1;
uniform sampler2D g_kTexture2;
uniform sampler2D g_kTexture3;

varying vec4 shadow;

void main (void)
{
	//get texture
  	vec4 c1 = texture2D(g_kTexture0,gl_TexCoord[0].st);

	//apply detail texture
	vec4 detail = texture2D(g_kTexture2,gl_TexCoord[0].st*6);		//detail texture
 	c1.xyz = c1.xyz*(1-detail.a) + (detail.xyz * detail.a);

	//shadow alpha
  	float s = texture2D(g_kTexture3,gl_TexCoord[3].st).a;
  	
	//get interpolated shadow/lit color
 	vec4 color = c1 *  ( (gl_Color*(1-s) )+(shadow*s) );

	//apply fog
	float fog = clamp((gl_Fog.end - gl_FogFragCoord) / (gl_Fog.end - gl_Fog.start),0,1);
 	color.xyz= (1-fog)*gl_Fog.color.xyz + fog*color.xyz;

// 	color.xyz= (1-gl_FogFragCoord)*gl_Fog.color.xyz + gl_FogFragCoord*color.xyz;

	//writeout color
	gl_FragColor = color ;
}
