uniform sampler2D g_kTexture0;
uniform sampler2D g_kTexture1;
uniform sampler2D g_kTexture2;
uniform sampler2D g_kTexture3;

varying vec4 shadow;
varying vec4 shadowspec;
varying vec4 otherspec;

uniform float g_fTime;

void main (void)
{
	//color texture
  	vec4 org = texture2D(g_kTexture0,gl_TexCoord[0].st);				//normal color texture

	//get specular map
 	vec4 spec = texture2D(g_kTexture1,gl_TexCoord[0].st); 			//specular map

	//get shadow map
 	float s = texture2D(g_kTexture3,gl_TexCoord[3].st).a;

	//interpolate shadow lighting
 	vec4 color = ( (gl_Color*(1-s) )+(shadow*s) );

	//interpolate specular lighting
	vec4 speccolor =  clamp(otherspec + shadowspec*(1-s),0,1);

  	
	//apply lighting
 	org *= color;

	//apply specular
  	org += spec * speccolor;	
	
	

	//apply fogz
	float fog = clamp((gl_Fog.end - gl_FogFragCoord) / (gl_Fog.end - gl_Fog.start),0,1);
	org.xyz = (1-fog)*gl_Fog.color.xyz + fog*org.xyz;
// 	org.xyz = (1-gl_FogFragCoord)*gl_Fog.color.xyz + gl_FogFragCoord*org.xyz;

	

	gl_FragColor = org;

}
