uniform vec3 g_kEyePosition;
uniform int  g_iActiveLights;

// varying float fog;
varying vec4 shadow;
varying vec4 shadowspec;
varying vec4 otherspec;


void main()
{
	float fDistance;
	float fAttenuation;
	vec3 kLightDir;
	vec4 kAmbient;
	vec4 kDiffuse;
	vec4 shadowdif;
	vec4 shadowamb;

 	vec4 color = vec4(0,0,0,1);

 	vec3 kNormal = normalize(gl_NormalMatrix * gl_Normal);
  	vec4 kVertex = gl_ModelViewMatrix * gl_Vertex;
	vec3 kEyeDir = vec3(0,0,1);

	//shadow light
	kLightDir = normalize(gl_LightSource[0].position).xyz;
	shadowamb = gl_LightSource[0].ambient;
 	shadowdif = max(dot(kLightDir,kNormal),0)*gl_LightSource[0].diffuse;


	vec3 speclightdir = normalize(kLightDir*10 - kVertex.xyz);
	vec3 s = normalize(speclightdir + kEyeDir);
 	shadowspec = pow(max(dot(s,kNormal),0),gl_FrontMaterial.shininess) * gl_LightSource[0].specular;

#FOR_EACH_LIGHT_START

		//point light
		fDistance = distance(gl_LightSource[#LIGHT].position.xyz,kVertex.xyz);

		fAttenuation = (1/(gl_LightSource[#LIGHT].constantAttenuation + 
								gl_LightSource[#LIGHT].linearAttenuation*fDistance + 
								gl_LightSource[#LIGHT].quadraticAttenuation*(fDistance*fDistance)));

		kLightDir = normalize(gl_LightSource[#LIGHT].position - kVertex.xyz);

		kAmbient = gl_LightSource[#LIGHT].ambient * fAttenuation;
		kDiffuse = max(dot(kLightDir,kNormal),0)*gl_LightSource[#LIGHT].diffuse * fAttenuation;


		s = normalize(kLightDir + kEyeDir);
 		otherspec += pow(max(dot(s,kNormal),0),gl_FrontMaterial.shininess) * gl_LightSource[#LIGHT].specular * fAttenuation;

		color += kAmbient+kDiffuse;
		
#FOR_EACH_LIGHT_STOP


 	shadow = color + shadowamb + shadowdif*0.1;
	color += shadowamb+shadowdif;
	
	shadow *= gl_Color;
	color *= gl_Color;

	shadow.a = gl_Color.a;
	color.a = gl_Color.a;

	shadow = clamp(shadow,0,1);
	shadowspec = clamp(shadowspec,0,1);
	otherspec = clamp(otherspec,0,1);
	gl_FrontColor = color;

	gl_TexCoord[0] = gl_MultiTexCoord0;
	gl_TexCoord[1] = gl_MultiTexCoord1;
	gl_TexCoord[2] = gl_MultiTexCoord2;
 	gl_TexCoord[3]  = kVertex *mat4(gl_EyePlaneS[3],gl_EyePlaneT[3],gl_EyePlaneR[3],gl_EyePlaneQ[3]);


	gl_Position = ftransform();
 	gl_FogFragCoord = gl_Position.z;
	//lgger en del av skuggberkningen hr, verkar bli snabbare
// 	gl_FogFragCoord =clamp((gl_Fog.end - gl_Position.z) / (gl_Fog.end - gl_Fog.start),0,1);;
}